/***********************************************************************************************/
/******** DANGER !! DANGER !! DANGER !! DO NOT EDIT FILE -- IT WAS GENERATED AUTOMATICALLY !!! */
/***********************************************************************************************/

/* $Id: $
 * This file is part of the SPHERE Pipeline
 * Copyright (C) 2007-2010 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: $
 * $Date: $
 * $Revision: $
 * $Name: $
 */

#include "sph_error.h"
#include "sph_cube.h"
#include "sph_pixel_description_table.h"
#include "sph_ldt.h"
#include "sph_master_frame.h"
#include "sph_double_image.h"
#include "sph_triple_image.h"
#include "sph_quad_image.h"
#include "sph_zpl_exposure.h"
#include "sph_zpl_exposure_imaging.h"
#include "sph_pixel_polyfit_table.h"
#include "sph_ird_instrument_model.h"
#include "sph_fctable.h"
#include "sph_zpl_science_pol_product.h"
#include <cpl.h>
#include <config.h>

#ifndef SPH_IRD_SCIENCE_IMAGING_H_

#define SPH_IRD_SCIENCE_IMAGING_H_
#define SPH_IRD_SCIENCE_IMAGING_VERSION SPHERE_REC_VERSIONS

/*-------------------------------------------------------------------------------
 * The Structure Definition
 * 
 * This structure contains the members of the sph_ird_science_imaging that are 
 * needed by the various methods.
 * 
 * ------------------------------------------------------------------------------
 */

typedef struct _sph_ird_science_imaging_ {
    cpl_frameset*                   inframes                              ; /* The recipe input frames */

    cpl_frameset*                   current_raw_frameset                  ; /* The frameset for one product */

    cpl_parameterlist*        inparams                              ; /* The recipe input parameters */

    cpl_parameterlist*        framecomb_parameterlist               ; /* The recipe input parameters */

    const char*                     science_imaging_outfilename           ; /* The parameter of ird.science_imaging.outfilename */

    const char*                     science_imaging_outfilename_left      ; /* The parameter of ird.science_imaging.outfilename_left */

    const char*                     science_imaging_outfilename_right     ; /* The parameter of ird.science_imaging.outfilename_right */

    int                             coll_alg                              ; /* The parameter of ird.science_imaging.coll_alg */

    short                           keep_fctable                          ; /* The parameter of ird.science_imaging.keep_fctable */

    short                           save_addprod                          ; /* The parameter of ird.science_imaging.save_addprod */

    short                           flag_adi                              ; /* The parameter of ird.science_imaging.use_adi */

    short                           fullset                               ; /* The parameter of ird.science_imaging.full_frameset_speck */

    int                             transform_method                      ; /* The parameter of ird.science_imaging.transform_method */

    int                             filter_method                         ; /* The parameter of ird.science_imaging.filter_method */

    double                          filter_radius                         ; /* The parameter of ird.science_imaging.filter_rad */

    double                          fermi_temp                            ; /* The parameter of ird.science_imaging.fermi_temp */

    double                          butter_pass                           ; /* The parameter of ird.science_imaging.butter_pass */

    double                          butter_stop                           ; /* The parameter of ird.science_imaging.butter_stop */

    double                          star_r                                ; /* The parameter of ird.science_imaging.star_r */

    double                          bg_r1                                 ; /* The parameter of ird.science_imaging.bg_r1 */

    double                          bg_r2                                 ; /* The parameter of ird.science_imaging.bg_r2 */

    cpl_frameset*                   rawframes                             ; /* The IRD_SCIENCE_IMAGING_RAW frames */

    cpl_frame*                      dark_frame                            ; /* The IRD_MASTER_DARK frames */

    cpl_frame*                      insbg_frame                           ; /* The IRD_INS_BG frames */

    cpl_frame*                      insbg_fit_frame                       ; /* The IRD_INS_BG_FIT frames */

    cpl_frame*                      skybg_frame                           ; /* The IRD_SKY_BG frames */

    cpl_frame*                      skybg_fit_frame                       ; /* The IRD_SKY_BG_FIT frames */

    cpl_frame*                      flat_frame                            ; /* The IRD_FLAT_FIELD frames */

    cpl_frame*                      distmap_frame                         ; /* The IRD_DISTORTION_MAP frames */

    cpl_frame*                      fcframe                               ; /* The IRD_STAR_CENTER frames */

    cpl_frameset*                   fcasciis                              ; /* The IRD_FCTABLE frames */

    cpl_frame*                      static_badpixel_frame                 ; /* The IRD_STATIC_BADPIXELMAP frames */

    cpl_frame*                      filter_frame                          ; /* The IRD_FILTER_TABLE frames */

    cpl_frame*                      star_frame                            ; /* The IRD_PHOT_STAR_TABLE frames */

} sph_ird_science_imaging;

/*-------------------------------------------------------------------------------
 * Error codes
 * 
 * Below the various error codes for this module are declared.
 * ------------------------------------------------------------------------------
 */

int sph_ird_science_imaging_create_test(cpl_plugin *);


/*-------------------------------------------------------------------------------
 * The methods
 * 
 * These are the methods for sph_ird_science_imaging.
 * 
 * ------------------------------------------------------------------------------
 */

sph_ird_science_imaging* sph_ird_science_imaging_new( cpl_frameset * frameset, 
                                              cpl_parameterlist * parlist);

sph_error_code  sph_ird_science_imaging_check_frames( sph_ird_science_imaging* self );

sph_error_code sph_ird_science_imaging_check_params( sph_ird_science_imaging* parlist );

cpl_error_code sph_ird_science_imaging_run( sph_ird_science_imaging* self );

sph_error_code sph_ird_science_imaging_delete( sph_ird_science_imaging* self );
cpl_parameterlist*  sph_ird_science_imaging_create_paramlist(void) CPL_ATTR_ALLOC;

/* Extra function declarations that are defined in sph_ird_science_imaging.c */


/* End of extra function declarations that are defined in sph_ird_science_imaging_run.c */



#endif /*SPH_IRD_SCIENCE_IMAGING_H_*/
